﻿////-----------------------------------------------
////jqDesigner 设计器
////Date：2021-03-04
////-----------------------------------------------
(function (window, $) {
    var PLUGIN_NAME = "jqDesigner";
    var uid = 0;
    //********************************************************
    //私有方法
    //********************************************************
    function _init(target, state, options) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        var selector = state.selector;
        selector.addClass("jquery-designer");
        //设计区域
        state.paintPanel = $("<div class='paintPanel'></div>");
        state.toolbar = $("<div class='toolbar'></div>");
        state.dragContainer = $("<div class='dragContainer'></div>");
        selector.append(state.paintPanel);
        selector.append(state.toolbar);
        selector.append(state.dragContainer);
        rendToolbar(target);
        rendDragItem(target);
    }
    function rendToolbar(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.toolbars.length; i++) {
            state.toolbar.append("<div>" + options.toolbars[i].name+"</div>")
        }
    }
    function rendDragItem(target) {
        var state = $.data(target, PLUGIN_NAME);
        var options = state.options;
        for (var i = 0; i < options.dragItems.length; i++) {
            state.dragContainer.append("<div></div>")
        }
    }
    function _getConfig(target) {
        var state = $.data(target, PLUGIN_NAME);
    }
    $.fn[PLUGIN_NAME] = function (options) {
        if (typeof options === 'string' && $.fn[PLUGIN_NAME].methods[options]) {
            return $.fn[PLUGIN_NAME].methods[options].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof options === 'object' || !options) {
            return $.fn[PLUGIN_NAME].methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + options + ' does not exist on jQuery' + PLUGIN_NAME);
        }
    };
    $.fn[PLUGIN_NAME].version = "1.0";
    $.fn[PLUGIN_NAME].defaults = {
        toolbars: [],
        dragItems: [],
    };
    $.fn[PLUGIN_NAME].methods = {
        init: function (options) {
            return this.each(function () {
                var $this = $(this);
                var state = $.data(this, PLUGIN_NAME);
                if (state) {
                    $.extend(state.options, options);
                } else {
                    var settings = $.extend({}, $.fn[PLUGIN_NAME].defaults, options);
                    state = $.data(this, PLUGIN_NAME, {
                        target: this,
                        selector: $this,
                        options: settings,
                        vars: {},
                    });
                    _init(this, state, options);
                }
            });
        },
        getConfig: function () {
            return _getConfig(this[0]);
        },
    };
})(window, jQuery);